<template>
  <div class="home">
    <div class="container">
      <control-panel>
        <template v-slot:right="">
          <div @click="toggleOrder">
            Сортировка по алфавиту <icon-toggle :color="sortBy === 'RANDOM' ? '#626262' : '#ffffff'" />
          </div>
        </template>
      </control-panel>
      <div class="dogs__list">
        <card :src="item.src" :name="item.name" v-for="(item, index) in items" :key="index" :size="index === 0 ? 3 : 1" />
      </div>
      <Observer @intersect="intersected"/>
    </div>
    <to-top />
  </div>
</template>

<script>
import { mapActions, mapGetters } from 'vuex'
import Card from '../components/Card'
import Observer from '../components/Observer'
import ToTop from '../components/ToTop'
import IconToggle from '../components/icons/IconToggle'
import ControlPanel from '../components/ControlPanel'
// @ is an alias to /src

export default {
  name: 'Home',
  components: {
    Card,
    Observer,
    ToTop,
    ControlPanel,
    IconToggle
  },
  data () {
    return {
      sortBy: 'RANDOM',
      page: 1
    }
  },
  computed: {
    ...mapGetters(['getDogs']),
    items () {
      if (this.sortBy === 'RANDOM') {
        return this.getDogs
      }
      return [...this.getDogs].sort((a, b) => {
        const nameA = a.name.toUpperCase()
        const nameB = b.name.toUpperCase()
        let comparison = 0
        if (nameA > nameB) {
          comparison = 1
        } else if (nameA < nameB) {
          comparison = -1
        }
        return comparison
      })
    }
  },
  methods: {
    ...mapActions(['fetchDogs']),
    intersected () {
      this.page++
      this.fetchDogs({ page: this.page })
    },
    toggleOrder () {
      this.sortBy = this.sortBy === 'RANDOM' ? 'ALPHABET' : 'RANDOM'
    }
  },
  created () {
    this.fetchDogs()
  },
  beforeDestroy () {
    this.$store.commit('CLEAR_DOGS')
  }
}
</script>

<style lang="scss">
$card-with: 367px;
.dogs__list {
  display: grid;
  grid-gap: 30px;
  grid-template-columns: $card-with $card-with $card-with;
}
</style>
